use serde::Serialize;

#[derive(Serialize, Clone)]
pub struct Query(pub Vec<(String, String)>);

impl Query {
    pub fn join(mut self, other: impl ToQuery) -> Self {
        self.0.extend(other.to_query().0);

        self
    }

    pub fn encode(self) -> String {
        serde_urlencoded::to_string(self).unwrap()
    }
}

pub trait ToQuery {
    fn to_query(self) -> Query;
}

impl ToQuery for Query {
    fn to_query(self) -> Query {
        self
    }
}
